#ifndef _CkDsa_H
#define _CkDsa_H
#include "Chilkat_C.h"

HCkDsa CkDsa_Create(void);
void CkDsa_Dispose(HCkDsa handle);
int CkDsa_getGroupSize(HCkDsa handle);
void CkDsa_putGroupSize(HCkDsa handle, int newVal);
void CkDsa_getHash(HCkDsa handle, HCkByteData retval);
void CkDsa_putHash(HCkDsa handle, HCkByteData  newVal);
void CkDsa_getHexG(HCkDsa handle, HCkString retval);
void CkDsa_getHexP(HCkDsa handle, HCkString retval);
void CkDsa_getHexQ(HCkDsa handle, HCkString retval);
void CkDsa_getHexX(HCkDsa handle, HCkString retval);
void CkDsa_getHexY(HCkDsa handle, HCkString retval);
void CkDsa_getLastErrorHtml(HCkDsa handle, HCkString retval);
void CkDsa_getLastErrorText(HCkDsa handle, HCkString retval);
void CkDsa_getLastErrorXml(HCkDsa handle, HCkString retval);
void CkDsa_getSignature(HCkDsa handle, HCkByteData retval);
void CkDsa_putSignature(HCkDsa handle, HCkByteData  newVal);
BOOL CkDsa_getUtf8(HCkDsa handle);
void CkDsa_putUtf8(HCkDsa handle, BOOL newVal);
void CkDsa_getVersion(HCkDsa handle, HCkString retval);
BOOL CkDsa_FromDer(HCkDsa handle, HCkByteData derData);
BOOL CkDsa_FromDerFile(HCkDsa handle, const char *filename);
BOOL CkDsa_FromEncryptedPem(HCkDsa handle, const char *password, const char *pemData);
BOOL CkDsa_FromPem(HCkDsa handle, const char *pemData);
BOOL CkDsa_FromPublicDer(HCkDsa handle, HCkByteData derData);
BOOL CkDsa_FromPublicDerFile(HCkDsa handle, const char *filename);
BOOL CkDsa_FromPublicPem(HCkDsa handle, const char *pemData);
BOOL CkDsa_FromXml(HCkDsa handle, const char *xmlKey);
BOOL CkDsa_GenKey(HCkDsa handle, int numBits);
BOOL CkDsa_GenKeyFromParamsDer(HCkDsa handle, HCkByteData derBytes);
BOOL CkDsa_GenKeyFromParamsDerFile(HCkDsa handle, const char *filename);
BOOL CkDsa_GenKeyFromParamsPem(HCkDsa handle, const char *pem);
BOOL CkDsa_GenKeyFromParamsPemFile(HCkDsa handle, const char *filename);
BOOL CkDsa_GetEncodedHash(HCkDsa handle, const char *encoding, HCkString outStr);
BOOL CkDsa_GetEncodedSignature(HCkDsa handle, const char *encoding, HCkString outStr);
BOOL CkDsa_LoadText(HCkDsa handle, const char *filename, HCkString outStr);
BOOL CkDsa_SaveLastError(HCkDsa handle, const char *filename);
BOOL CkDsa_SaveText(HCkDsa handle, const char *strToSave, const char *filename);
BOOL CkDsa_SetEncodedHash(HCkDsa handle, const char *encoding, const char *encodedHash);
BOOL CkDsa_SetEncodedSignature(HCkDsa handle, const char *encoding, const char *encodedSig);
BOOL CkDsa_SetKeyExplicit(HCkDsa handle, int groupSizeInBytes, const char *pHex, const char *qHex, const char *gHex, const char *xHex);
BOOL CkDsa_SetPubKeyExplicit(HCkDsa handle, int groupSizeInBytes, const char *pHex, const char *qHex, const char *gHex, const char *yHex);
BOOL CkDsa_SignHash(HCkDsa handle);
BOOL CkDsa_ToDer(HCkDsa handle, HCkByteData outBytes);
BOOL CkDsa_ToDerFile(HCkDsa handle, const char *filename);
BOOL CkDsa_ToEncryptedPem(HCkDsa handle, const char *password, HCkString outStr);
BOOL CkDsa_ToPem(HCkDsa handle, HCkString outStr);
BOOL CkDsa_ToPublicDer(HCkDsa handle, HCkByteData outBytes);
BOOL CkDsa_ToPublicDerFile(HCkDsa handle, const char *filename);
BOOL CkDsa_ToPublicPem(HCkDsa handle, HCkString outStr);
BOOL CkDsa_ToXml(HCkDsa handle, BOOL bPublicOnly, HCkString outStr);
BOOL CkDsa_UnlockComponent(HCkDsa handle, const char *unlockCode);
BOOL CkDsa_Verify(HCkDsa handle);
BOOL CkDsa_VerifyKey(HCkDsa handle);
const char *CkDsa_getEncodedHash(HCkDsa handle, const char *encoding);
const char *CkDsa_getEncodedSignature(HCkDsa handle, const char *encoding);
const char *CkDsa_hexG(HCkDsa handle);
const char *CkDsa_hexP(HCkDsa handle);
const char *CkDsa_hexQ(HCkDsa handle);
const char *CkDsa_hexX(HCkDsa handle);
const char *CkDsa_hexY(HCkDsa handle);
const char *CkDsa_lastErrorHtml(HCkDsa handle);
const char *CkDsa_lastErrorText(HCkDsa handle);
const char *CkDsa_lastErrorXml(HCkDsa handle);
const char *CkDsa_loadText(HCkDsa handle, const char *filename);
const char *CkDsa_toEncryptedPem(HCkDsa handle, const char *password);
const char *CkDsa_toPem(HCkDsa handle);
const char *CkDsa_toPublicPem(HCkDsa handle);
const char *CkDsa_toXml(HCkDsa handle, BOOL bPublicOnly);
const char *CkDsa_version(HCkDsa handle);
#endif
